Loading...
Searching...
No Matches
lz4.c File Reference
`#include "lz4.h"`
`#include <stdlib.h>`
`#include <string.h>`
`#include <limits.h>`
Include dependency graph for lz4.c:

Go to the source code of this file.

## Macros

#define | LZ4_HEAPMODE 0
#define | LZ4_ACCELERATION_DEFAULT 1
#define | LZ4_ACCELERATION_MAX 65537
#define | LZ4_SRC_INCLUDED 1
#define | LZ4_DISABLE_DEPRECATE_WARNINGS
#define | LZ4_STATIC_LINKING_ONLY
#define | LZ4_FORCE_INLINE static
#define | LZ4_FORCE_O2
#define | expect(expr, value)
#define | likely(expr)
#define | unlikely(expr)
#define | LZ4_ALIGN_TEST 1
#define | ALLOC(s)
#define | ALLOC_AND_ZERO(s)
#define | FREEMEM(p)
#define | LZ4_memset(p, v, s)
#define | MEM_INIT(p, v, s)
#define | MINMATCH 4
#define | WILDCOPYLENGTH 8
#define | LASTLITERALS
#define | MFLIMIT 12 /* see ../doc/lz4_Block_format.md#parsing-restrictions */
#define | MATCH_SAFEGUARD_DISTANCE
#define | FASTLOOP_SAFE_DISTANCE 64
#define | KB *(1 << 10)
#define | MB *(1 << 20)
#define | GB *(1U << 30)
#define | LZ4_DISTANCE_ABSOLUTE_MAX 65535
#define | ML_BITS 4
#define | ML_MASK ((1U << ML_BITS) - 1)
#define | RUN_BITS (8 - ML_BITS)
#define | RUN_MASK ((1U << RUN_BITS) - 1)
#define | assert(condition)
#define | LZ4_STATIC_ASSERT(c)
#define | DEBUGLOG(l, ...)
#define | LZ4_memcpy(dst, src, size)
#define | LZ4_memmove memmove
#define | LZ4_FAST_DEC_LOOP 0
#define | STEPSIZE sizeof(reg_t)
#define | HASH_UNIT sizeof(reg_t)
#define | MIN(a, b)

## Typedefs

typedef unsigned char | BYTE
typedef unsigned short | U16
typedef unsigned int | U32
typedef signed int | S32
typedef unsigned long long | U64
typedef size_t | uptrval
typedef size_t | reg_t
typedef size_t | Rvl_t

## Enumerations

enum | limitedOutput_directive { notLimited = 0 , limitedOutput = 1 , fillOutput = 2 }
enum | tableType_t { clearedTable = 0 , byPtr , byU32 , byU16 }
enum | dict_directive { noDict = 0 , withPrefix64k , usingExtDict , usingDictCtx }
enum | dictIssue_directive { noDictIssue = 0 , dictSmall }
enum | LoadDict_mode_e { _ld_fast , _ld_slow }
enum | earlyEnd_directive { decode_full_block = 0 , partial_decode = 1 }

## Functions

int | LZ4_versionNumber (void)
const char * | LZ4_versionString (void)
int | LZ4_compressBound (int isize)
int | LZ4_sizeofState (void)
int | LZ4_compress_forceExtDict (LZ4_stream_t *LZ4_dict, const char *source, char *dest, int srcSize)
int | LZ4_decompress_safe_forceExtDict (const char *source, char *dest, int compressedSize, int maxOutputSize, const void *dictStart, size_t dictSize)
int | LZ4_decompress_safe_partial_forceExtDict (const char *source, char *dest, int compressedSize, int targetOutputSize, int dstCapacity, const void *dictStart, size_t dictSize)
int | LZ4_compress_fast_extState (void *state, const char *source, char *dest, int inputSize, int maxOutputSize, int acceleration)
int | LZ4_compress_fast_extState_fastReset (void *state, const char *src, char *dst, int srcSize, int dstCapacity, int acceleration)
int | LZ4_compress_fast (const char *src, char *dest, int srcSize, int dstCapacity, int acceleration)
int | LZ4_compress_default (const char *src, char *dst, int srcSize, int dstCapacity)
int | LZ4_compress_destSize_extState (void *state, const char *src, char *dst, int *srcSizePtr, int targetDstSize, int acceleration)
int | LZ4_compress_destSize (const char *src, char *dst, int *srcSizePtr, int targetDstSize)
LZ4_stream_t * | LZ4_createStream (void)
LZ4_stream_t * | LZ4_initStream (void *buffer, size_t size)
void | LZ4_resetStream (LZ4_stream_t *LZ4_stream)
void | LZ4_resetStream_fast (LZ4_stream_t *ctx)
int | LZ4_freeStream (LZ4_stream_t *LZ4_stream)
int | LZ4_loadDict_internal (LZ4_stream_t *LZ4_dict, const char *dictionary, int dictSize, LoadDict_mode_e _ld)
int | LZ4_loadDict (LZ4_stream_t *LZ4_dict, const char *dictionary, int dictSize)
int | LZ4_loadDictSlow (LZ4_stream_t *LZ4_dict, const char *dictionary, int dictSize)
void | LZ4_attach_dictionary (LZ4_stream_t *workingStream, const LZ4_stream_t *dictionaryStream)
int | LZ4_compress_fast_continue (LZ4_stream_t *LZ4_stream, const char *source, char *dest, int inputSize, int maxOutputSize, int acceleration)
int | LZ4_saveDict (LZ4_stream_t *LZ4_dict, char *safeBuffer, int dictSize)

## Macro Definition Documentation

## ALLOC

#define ALLOC | ( |  | s | ) |

Value:
malloc(s)

LZ4_STATIC_LINKING_ONLY_DISABLE_MEMORY_ALLOCATION : Disable relatively high-level LZ4/HC functions that use dynamic memory allocation functions (malloc(), calloc(), free()).

Note that this is a compile-time switch. And since it disables public/stable LZ4 v1 API functions, we don't recommend using this symbol to generate a library for distribution.

The following public functions are removed when this symbol is defined.

- lz4 : LZ4_createStream, LZ4_freeStream, LZ4_createStreamDecode, LZ4_freeStreamDecode, LZ4_create (deprecated)
- lz4hc : LZ4_createStreamHC, LZ4_freeStreamHC, LZ4_createHC (deprecated), LZ4_freeHC (deprecated)
- lz4frame, lz4file : All LZ4F_* functions

Definition at line 241 of file lz4.c.

Referenced by LZ4_createStream().

## ALLOC_AND_ZERO

#define ALLOC_AND_ZERO | ( |  | s | ) |

Value:
calloc(1, s)

Definition at line 242 of file lz4.c.

## assert

#define assert | ( |  | condition | ) |

Value:
((void)0)

Definition at line 291 of file lz4.c.

Referenced by ami_single_temp_name(), DBFOpenLL(), G_math_Asp_to_sband_matrix(), G_math_solver_sparse_gs(), G_math_solver_sparse_jacobi(), G_rc_path(), LZ4_compress_fast_extState_fastReset(), LZ4_saveDict(), open_stream(), open_stream(), rbtree_create(), rbtree_find(), rbtree_init_trav(), rbtree_insert(), rbtree_remove(), rbtree_traverse(), rbtree_traverse_backwd(), rbtree_traverse_start(), SHPSetFastModeReadObject(), and SHPWriteObject().

## DEBUGLOG

#define DEBUGLOG | ( |  | l,
|  |  | ... )

Value:
{ \
} /* disabled */

Definition at line 312 of file lz4.c.

Referenced by LZ4_createStream(), LZ4_resetStream(), and LZ4_saveDict().

## expect

#define expect | ( |  | expr,
|  |  | value )

Value:
(expr)

Definition at line 189 of file lz4.c.

## FASTLOOP_SAFE_DISTANCE

#define FASTLOOP_SAFE_DISTANCE 64

Definition at line 266 of file lz4.c.

## FREEMEM

#define FREEMEM | ( |  | p | ) |

Value:
free(p)

Definition at line 243 of file lz4.c.

## GB

#define GB *(1U << 30)

Definition at line 271 of file lz4.c.

## HASH_UNIT

#define HASH_UNIT sizeof(reg_t)

Definition at line 1957 of file lz4.c.

## KB

#define KB *(1 << 10)

Definition at line 269 of file lz4.c.

Referenced by LZ4_saveDict().

## LASTLITERALS

#define LASTLITERALS

Value:
5 /* see ../doc/lz4_Block_format.md#parsing-restrictions \
*/

Definition at line 260 of file lz4.c.

## likely

#define likely | ( |  | expr | ) |

Value:
expect((expr) != 0, 1)
expect
#define expect(expr, value)
Definition lz4.c:189

Definition at line 193 of file lz4.c.

## LZ4_ACCELERATION_DEFAULT

#define LZ4_ACCELERATION_DEFAULT 1

Definition at line 53 of file lz4.c.

Referenced by LZ4_compress_fast_extState_fastReset().

## LZ4_ACCELERATION_MAX

#define LZ4_ACCELERATION_MAX 65537

Definition at line 59 of file lz4.c.

Referenced by LZ4_compress_fast_extState_fastReset().

## LZ4_ALIGN_TEST

#define LZ4_ALIGN_TEST 1

Definition at line 202 of file lz4.c.

## LZ4_DISABLE_DEPRECATE_WARNINGS

#define LZ4_DISABLE_DEPRECATE_WARNINGS

Value:
/* due to \
LZ4_decompress_safe_withPrefix64k */

Definition at line 115 of file lz4.c.

## LZ4_DISTANCE_ABSOLUTE_MAX

#define LZ4_DISTANCE_ABSOLUTE_MAX 65535

Definition at line 273 of file lz4.c.

## LZ4_FAST_DEC_LOOP

#define LZ4_FAST_DEC_LOOP 0

Definition at line 561 of file lz4.c.

## LZ4_FORCE_INLINE

#define LZ4_FORCE_INLINE static

Definition at line 155 of file lz4.c.

## LZ4_FORCE_O2

#define LZ4_FORCE_O2

Definition at line 181 of file lz4.c.

## LZ4_HEAPMODE

#define LZ4_HEAPMODE 0

Definition at line 46 of file lz4.c.

## LZ4_memcpy

#define LZ4_memcpy | ( |  | dst,
|  |  | src,
|  |  | size )

Value:
memcpy(dst, src, size)

LZ4 relies on memcpy with a constant size being inlined. In freestanding environments, the compiler can't assume the implementation of memcpy() is standard compliant, so it can't apply its specialized memcpy() inlining logic. When possible, use __builtin_memcpy() to tell the compiler to analyze memcpy() as if it were standard compliant, so it can inline it in freestanding environments. This is needed when decompressing the Linux Kernel, for example.

Definition at line 376 of file lz4.c.

## LZ4_memmove

#define LZ4_memmove memmove

Definition at line 384 of file lz4.c.

Referenced by LZ4_saveDict().

## LZ4_memset

#define LZ4_memset | ( |  | p,
|  |  | v,
|  |  | s )

Value:
memset((p), (v), (s))

Definition at line 250 of file lz4.c.

## LZ4_SRC_INCLUDED

#define LZ4_SRC_INCLUDED 1

Definition at line 111 of file lz4.c.

## LZ4_STATIC_ASSERT

#define LZ4_STATIC_ASSERT | ( |  | c | ) |

Value:
{ \
enum { LZ4_static_assert = 1 / (int)(!!(c)) }; \
} /* use after variable declarations */

Definition at line 295 of file lz4.c.

Referenced by LZ4_createStream().

## LZ4_STATIC_LINKING_ONLY

#define LZ4_STATIC_LINKING_ONLY

Definition at line 119 of file lz4.c.

## MATCH_SAFEGUARD_DISTANCE

#define MATCH_SAFEGUARD_DISTANCE

Value:
((2 * WILDCOPYLENGTH) - \
MINMATCH) /* ensure it's possible to write 2 x wildcopyLength without \
overflowing output buffer */
MINMATCH
#define MINMATCH
Definition lz4.c:257
WILDCOPYLENGTH
#define WILDCOPYLENGTH
Definition lz4.c:259

Definition at line 263 of file lz4.c.

## MB

#define MB *(1 << 20)

Definition at line 270 of file lz4.c.

## MEM_INIT

#define MEM_INIT | ( |  | p,
|  |  | v,
|  |  | s )

Value:
LZ4_memset((p), (v), (s))
LZ4_memset
#define LZ4_memset(p, v, s)
Definition lz4.c:250

Definition at line 252 of file lz4.c.

## MFLIMIT

#define MFLIMIT 12 /* see ../doc/lz4_Block_format.md#parsing-restrictions */

Definition at line 262 of file lz4.c.

## MIN

#define MIN | ( |  | a,
|  |  | b )

Value:
((a) < (b) ? (a) : (b))
b
double b
Definition driver/set_window.c:5

Definition at line 2273 of file lz4.c.

## MINMATCH

#define MINMATCH 4

Definition at line 257 of file lz4.c.

## ML_BITS

#define ML_BITS 4

Definition at line 279 of file lz4.c.

## ML_MASK

#define ML_MASK ((1U << ML_BITS) - 1)

Definition at line 280 of file lz4.c.

## RUN_BITS

#define RUN_BITS (8 - ML_BITS)

Definition at line 281 of file lz4.c.

## RUN_MASK

#define RUN_MASK ((1U << RUN_BITS) - 1)

Definition at line 282 of file lz4.c.

## STEPSIZE

#define STEPSIZE sizeof(reg_t)

Definition at line 782 of file lz4.c.

## unlikely

#define unlikely | ( |  | expr | ) |

Value:
expect((expr) != 0, 0)

Definition at line 196 of file lz4.c.

## WILDCOPYLENGTH

#define WILDCOPYLENGTH 8

Definition at line 259 of file lz4.c.

## Typedef Documentation

## BYTE

typedef unsigned char BYTE

Definition at line 339 of file lz4.c.

## reg_t

typedef size_t reg_t

Definition at line 350 of file lz4.c.

## Rvl_t

typedef size_t Rvl_t

Definition at line 2426 of file lz4.c.

## S32

typedef signed int S32

Definition at line 342 of file lz4.c.

## U16

typedef unsigned short U16

Definition at line 340 of file lz4.c.

## U32

typedef unsigned int U32

Definition at line 341 of file lz4.c.

## U64

typedef unsigned long long U64

Definition at line 343 of file lz4.c.

## uptrval

typedef size_t uptrval

Definition at line 344 of file lz4.c.

## Enumeration Type Documentation

## dict_directive

enum dict_directive

This enum distinguishes several different modes of accessing previous content in the stream.

- noDict : There is no preceding content.
- withPrefix64k : Table entries up to ctx->dictSize before the current blob blob being compressed are valid and refer to the preceding content (of length ctx->dictSize), which is available contiguously preceding in memory the content currently being compressed.
- usingExtDict : Like withPrefix64k, but the preceding content is somewhere else in memory, starting at ctx->dictionary with length ctx->dictSize.
- usingDictCtx : Everything concerning the preceding content is in a separate context, pointed to by ctx->dictCtx. ctx->dictionary, ctx->dictSize, and table entries in the current context that refer to positions preceding the beginning of the current compression are ignored. Instead, ctx->dictCtx->dictionary and ctx->dictCtx ->dictSize describe the location and size of the preceding content, and matches are found by looking in the ctx ->dictCtx->hashTable.

Enumerator
noDict |
withPrefix64k |
usingExtDict |
usingDictCtx |

Definition at line 860 of file lz4.c.

## dictIssue_directive

enum dictIssue_directive

Enumerator
noDictIssue |
dictSmall |

Definition at line 866 of file lz4.c.

## earlyEnd_directive

enum earlyEnd_directive

Enumerator
decode_full_block |
partial_decode |

Definition at line 2270 of file lz4.c.

## limitedOutput_directive

enum limitedOutput_directive

Enumerator
notLimited |
limitedOutput |
fillOutput |

Definition at line 353 of file lz4.c.

## LoadDict_mode_e

enum LoadDict_mode_e

Enumerator
_ld_fast |
_ld_slow |

Definition at line 1956 of file lz4.c.

## tableType_t

enum tableType_t

Enumerator
clearedTable |
byPtr |
byU32 |
byU16 |

Definition at line 835 of file lz4.c.

## Function Documentation

## LZ4_attach_dictionary()

void LZ4_attach_dictionary | ( | LZ4_stream_t * | workingStream,
|  | const LZ4_stream_t * | dictionaryStream )

LZ4_attach_dictionary() : stable since v1.10.0

This allows efficient re-use of a static dictionary multiple times.

Rather than re-loading the dictionary buffer into a working context before each compression, or copying a pre-loaded dictionary's LZ4_stream_t into a working LZ4_stream_t, this function introduces a no-copy setup mechanism, in which the working stream references `dictionaryStream` in-place.

Several assumptions are made about the state of `dictionaryStream`. Currently, only states which have been prepared by LZ4_loadDict() or LZ4_loadDictSlow() should be expected to work.

Alternatively, the provided `dictionaryStream` may be NULL, in which case any existing dictionary stream is unset.

If a dictionary is provided, it replaces any pre-existing stream history. The dictionary contents are the only history that can be referenced and logically immediately precede the data compressed in the first subsequent compression call.

The dictionary will only remain attached to the working stream through the first compression call, at the end of which it is cleared. `dictionaryStream` stream (and source buffer) must remain in-place / accessible / unchanged through the completion of the compression session.

Note: there is no equivalent LZ4_attach_*() method on the decompression side because there is no initialization cost, hence no need to share the cost across multiple sessions. To decompress LZ4 blocks using dictionary, attached or not, just employ the regular LZ4_setStreamDecode() for streaming, or the stateless LZ4_decompress_safe_usingDict() for one-shot decompression.

Definition at line 2035 of file lz4.c.

References _ld_slow.

## LZ4_compress_default()

int LZ4_compress_default | ( | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity )

LZ4_compress_default() : Compresses 'srcSize' bytes from buffer 'src' into already allocated 'dst' buffer of size 'dstCapacity'. Compression is guaranteed to succeed if 'dstCapacity' >= LZ4_compressBound(srcSize). It also runs faster, so it's a recommended setting. If the function cannot compress 'src' into a more limited 'dst' budget, compression stops immediately, and the function result is zero. In which case, 'dst' content is undefined (invalid).

Parameters

  srcSize | max supported value is LZ4_MAX_INPUT_SIZE.
  dstCapacity | size of buffer 'dst' (which must be already allocated)

Returns
  the number of bytes written into buffer 'dst' (necessarily <= dstCapacity) or 0 if compression fails Note : This function is protected against buffer overflow scenarios (never writes outside 'dst' buffer, nor read outside 'source' buffer).

Definition at line 1808 of file lz4.c.

Referenced by G_lz4_compress().

## LZ4_compress_destSize()

int LZ4_compress_destSize | ( | const char * | src,
|  | char * | dst,
|  | int * | srcSizePtr,
|  | int | targetDstSize )

LZ4_compress_destSize() : Reverse the logic : compresses as much data as possible from 'src' buffer into already allocated buffer 'dst', of size >= 'dstCapacity'. This function either compresses the entire 'src' content into 'dst' if it's large enough, or fill 'dst' buffer completely with as much data as possible from 'src'. note: acceleration parameter is fixed to "default".

Parameters

  [in,out] | srcSizePtr | Initially contains size of input. Will be modified to indicate how many bytes where read from 'src' to fill 'dst'. New value is necessarily <= input value.

Returns
  Nb bytes written into 'dst' (necessarily <= dstCapacity) or 0 if compression fails.

Note : from v1.8.2 to v1.9.1, this function had a bug (fixed in v1.9.2+): the produced compressed content could, in specific circumstances, require to be decompressed into a destination buffer larger by at least 1 byte than the content to decompress. If an application uses LZ4_compress_destSize(), it's highly recommended to update liblz4 to v1.9.2 or better. If this can't be done or ensured, the receiving decompression function should provide a dstCapacity which is > decompressedSize, by at least 1 byte. See https://github.com/lz4/lz4/issues/859 for details

Definition at line 1865 of file lz4.c.

References r.

## LZ4_compress_destSize_extState()

int LZ4_compress_destSize_extState | ( | void * | state,
|  | const char * | src,
|  | char * | dst,
|  | int * | srcSizePtr,
|  | int | targetDstSize,
|  | int | acceleration )

Definition at line 1853 of file lz4.c.

## LZ4_compress_fast()

int LZ4_compress_fast | ( | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | int | acceleration )

LZ4_compress_fast() : Same as LZ4_compress_default(), but allows selection of "acceleration" factor. The larger the acceleration value, the faster the algorithm, but also the lesser the compression. It's a trade-off. It can be fine tuned, with each successive value providing roughly +~3% to speed. An acceleration value of "1" is the same as regular LZ4_compress_default() Values <= 0 will be replaced by LZ4_ACCELERATION_DEFAULT (currently == 1, see lz4.c). Values > LZ4_ACCELERATION_MAX will be replaced by LZ4_ACCELERATION_MAX (currently == 65537, see lz4.c).

Definition at line 1786 of file lz4.c.

## LZ4_compress_fast_continue()

int LZ4_compress_fast_continue | ( | LZ4_stream_t * | streamPtr,
|  | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | int | acceleration )

LZ4_compress_fast_continue() : Compress 'src' content using data from previously compressed blocks, for better compression ratio. 'dst' buffer must be already allocated. If dstCapacity >= LZ4_compressBound(srcSize), compression is guaranteed to succeed, and runs faster.

Returns
  size of compressed block or 0 if there is an error (typically, cannot fit into 'dst').

Note 1 : Each invocation to LZ4_compress_fast_continue() generates a new block. Each block has precise boundaries. Each block must be decompressed separately, calling LZ4_decompress_*() with relevant metadata. It's not possible to append blocks together and expect a single invocation of LZ4_decompress_*() to decompress them together.

Note 2 : The previous 64KB of source data is assumed to remain present, unmodified, at same address in memory !

Note 3 : When input is structured as a double-buffer, each buffer can have any size, including < 64 KB. Make sure that buffers are separated, by at least one byte. This construction ensures that each block only depends on previous block.

Note 4 : If input buffer is a ring-buffer, it can have any size, including < 64 KB.

Note 5 : After an error, the stream status is undefined (invalid), it can only be reset or freed.

Definition at line 2087 of file lz4.c.

## LZ4_compress_fast_extState()

int LZ4_compress_fast_extState | ( | void * | state,
|  | const char * | source,
|  | char * | dest,
|  | int | inputSize,
|  | int | maxOutputSize,
|  | int | acceleration )

Definition at line 1666 of file lz4.c.

## LZ4_compress_fast_extState_fastReset()

int LZ4_compress_fast_extState_fastReset | ( | void * | state,
|  | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | int | acceleration )

LZ4_compress_fast_extState_fastReset() : A variant of LZ4_compress_fast_extState().

Using this variant avoids an expensive initialization step. It is only safe to call if the state buffer is known to be correctly initialized already (see comment in lz4.h on LZ4_resetStream_fast() for a definition of "correctly initialized").

Definition at line 1720 of file lz4.c.

References assert, byPtr, byU16, byU32, LZ4_stream_t_internal::currentOffset, dictSmall, limitedOutput, LZ4_ACCELERATION_DEFAULT, LZ4_ACCELERATION_MAX, LZ4_compressBound(), noDict, noDictIssue, notLimited, and NULL.

## LZ4_compress_forceExtDict()

int LZ4_compress_forceExtDict | ( | LZ4_stream_t * | LZ4_dict,
|  | const char * | source,
|  | char * | dest,
|  | int | srcSize )

Definition at line 2204 of file lz4.c.

## LZ4_compressBound()

int LZ4_compressBound | ( | int | inputSize | ) |

LZ4_compressBound() : Provides the maximum size that LZ4 compression may output in a "worst case" scenario (input data not compressible) This function is primarily useful for memory allocation purposes (destination buffer size). Macro LZ4_COMPRESSBOUND() is also provided for compilation-time evaluation (stack memory allocation for example). Note that LZ4_compress_default() compresses faster when dstCapacity is >= LZ4_compressBound(srcSize)

Parameters

  inputSize | max supported value is LZ4_MAX_INPUT_SIZE

Returns
  maximum output size in a "worst case" scenario or 0, if input size is incorrect (too large or negative)

Definition at line 879 of file lz4.c.

References LZ4_VERSION_STRING.

Referenced by G_lz4_compress_bound(), and LZ4_compress_fast_extState_fastReset().

## LZ4_createStream()

LZ4_stream_t * LZ4_createStream | ( | void |  | ) |

Note about RC_INVOKED

- RC_INVOKED is predefined symbol of rc.exe (the resource compiler which is part of MSVC/Visual Studio). https://docs.microsoft.com/en-us/windows/win32/menurc/predefined-macros
- Since rc.exe is a legacy compiler, it truncates long symbol (> 30 chars) and reports warning "RC4011: identifier truncated".
- To eliminate the warning, we surround long preprocessor symbol with "#if !defined(RC_INVOKED) ... #endif" block that means "skip this block when rc.exe is trying to read it".

Definition at line 1892 of file lz4.c.

References ALLOC, DEBUGLOG, LZ4_initStream(), LZ4_STATIC_ASSERT, and NULL.

## LZ4_decompress_safe_forceExtDict()

int LZ4_decompress_safe_forceExtDict | ( | const char * | source,
|  | char * | dest,
|  | int | compressedSize,
|  | int | maxOutputSize,
|  | const void * | dictStart,
|  | size_t | dictSize )

## LZ4_decompress_safe_partial_forceExtDict()

int LZ4_decompress_safe_partial_forceExtDict | ( | const char * | source,
|  | char * | dest,
|  | int | compressedSize,
|  | int | targetOutputSize,
|  | int | dstCapacity,
|  | const void * | dictStart,
|  | size_t | dictSize )

## LZ4_freeStream()

int LZ4_freeStream | ( | LZ4_stream_t * | LZ4_stream | ) |

Definition at line 1946 of file lz4.c.

## LZ4_initStream()

LZ4_stream_t * LZ4_initStream | ( | void * | stateBuffer,
|  | size_t | size )

LZ4_initStream() : v1.9.0+ An LZ4_stream_t structure must be initialized at least once. This is automatically done when invoking LZ4_createStream(), but it's not when the structure is simply declared on stack (for example).

Use LZ4_initStream() to properly initialize a newly declared LZ4_stream_t. It can also initialize any arbitrary buffer of sufficient size, and will

Returns
  a pointer of proper type upon initialization.

Note : initialization fails if size and alignment conditions are not respected. In which case, the function will

Returns
  NULL. Note2: An LZ4_stream_t structure guarantees correct alignment and size. Note3: Before v1.9.0, use LZ4_resetStream() instead

Definition at line 1917 of file lz4.c.

Referenced by LZ4_createStream().

## LZ4_loadDict()

int LZ4_loadDict | ( | LZ4_stream_t * | streamPtr,
|  | const char * | dictionary,
|  | int | dictSize )

LZ4_loadDict() : Use this function to reference a static dictionary into LZ4_stream_t. The dictionary must remain available during compression. LZ4_loadDict() triggers a reset, so any previous data will be forgotten. The same dictionary will have to be loaded on decompression side for successful decoding. Dictionary are useful for better compression of small data (KB range). While LZ4 itself accepts any input as dictionary, dictionary efficiency is also a topic. When in doubt, employ the Zstandard's Dictionary Builder. Loading a size of 0 is allowed, and is the same as reset.

Returns
  loaded dictionary size, in bytes (note: only the last 64 KB are loaded)

Definition at line 2024 of file lz4.c.

## LZ4_loadDict_internal()

int LZ4_loadDict_internal | ( | LZ4_stream_t * | LZ4_dict,
|  | const char * | dictionary,
|  | int | dictSize,
|  | LoadDict_mode_e | _ld )

Definition at line 1958 of file lz4.c.

References _ld_fast, and _ld_slow.

## LZ4_loadDictSlow()

int LZ4_loadDictSlow | ( | LZ4_stream_t * | streamPtr,
|  | const char * | dictionary,
|  | int | dictSize )

LZ4_loadDictSlow() : v1.10.0+ Same as LZ4_loadDict(), but uses a bit more cpu to reference the dictionary content more thoroughly. This is expected to slightly improve compression ratio. The extra-cpu cost is likely worth it if the dictionary is re-used across multiple sessions.

Returns
  loaded dictionary size, in bytes (note: only the last 64 KB are loaded)

Definition at line 2029 of file lz4.c.

References _ld_fast.

## LZ4_resetStream()

void LZ4_resetStream | ( | LZ4_stream_t * | streamPtr | ) |

LZ4_resetStream() : An LZ4_stream_t structure must be initialized at least once. This is done with LZ4_initStream(), or LZ4_resetStream(). Consider switching to LZ4_initStream(), invoking LZ4_resetStream() will trigger deprecation warnings in the future.

Definition at line 1934 of file lz4.c.

References DEBUGLOG.

Referenced by LZ4_decompress_fast_usingDict().

## LZ4_resetStream_fast()

void LZ4_resetStream_fast | ( | LZ4_stream_t * | streamPtr | ) |

LZ4_resetStream_fast() : v1.9.0+ Use this to prepare an LZ4_stream_t for a new chain of dependent blocks (e.g., LZ4_compress_fast_continue()).

An LZ4_stream_t must be initialized once before usage. This is automatically done when created by LZ4_createStream(). However, should the LZ4_stream_t be simply declared on stack (for example), it's necessary to initialize it first, using LZ4_initStream().

After init, start any new stream with LZ4_resetStream_fast(). A same LZ4_stream_t can be re-used multiple times consecutively and compress multiple streams, provided that it starts each new stream with LZ4_resetStream_fast().

LZ4_resetStream_fast() is much faster than LZ4_initStream(), but is not compatible with memory regions containing garbage data.

Note: it's only useful to call LZ4_resetStream_fast() in the context of streaming compression. The extState functions perform their own resets. Invoking LZ4_resetStream_fast() before is redundant, and even counterproductive.

Definition at line 1940 of file lz4.c.

## LZ4_saveDict()

int LZ4_saveDict | ( | LZ4_stream_t * | LZ4_dict,
|  | char * | safeBuffer,
|  | int | dictSize )

LZ4_saveDict() : If previously compressed data block is not guaranteed to remain available at its memory location, save it into a safer place (char* safeBuffer). Note : no need to call LZ4_loadDict() afterwards, dictionary is immediately usable, one can therefore call LZ4_compress_fast_continue() right after.

Returns
  : saved dictionary size in bytes (necessarily <= dictSize), or 0 if error.

Definition at line 2238 of file lz4.c.

References assert, DEBUGLOG, LZ4_stream_t_internal::dictionary, LZ4_stream_t_internal::dictSize, LZ4_stream_u::internal_donotuse, KB, LZ4_memmove, and NULL.

## LZ4_sizeofState()

int LZ4_sizeofState | ( | void |  | ) |

LZ4_compress_fast_extState() : Same as LZ4_compress_fast(), using an externally allocated memory space for its state. Use LZ4_sizeofState() to know how much memory must be allocated, and allocate it on 8-bytes boundaries (using malloc() typically). Then, provide this buffer as void* state to compression function.

Definition at line 883 of file lz4.c.

References LZ4_COMPRESSBOUND.

## LZ4_versionNumber()

int LZ4_versionNumber | ( | void |  | ) |

library version number; useful to check dll version; requires v1.3.0+

Definition at line 871 of file lz4.c.

## LZ4_versionString()

const char * LZ4_versionString | ( | void |  | ) |

library version string; useful to check dll version; requires v1.7.5+

Definition at line 875 of file lz4.c.

References LZ4_VERSION_NUMBER.